<?php
/**
 * This file contains a random assortment of useful functions and classes.
 *
 * @package Developer
 */

require_once('DBConnection.php');

function error($t) {
    print ("$t\n");
}

function debug($level,$t) {
    if ( Config::$DEBUG_LEVEL >= $level ) {
        ob_start();
        print "($level) ";
        print_r($t);
        $output = ob_get_clean();
        if( Config::$DEBUG_FILE) {
            $f = fopen(Config::$DEBUG_FILE,"a");
            fwrite($f,$output);
            fclose($f);
        } else {
            print $output;
        }
    }
}

function fetch_raw_db_data($table, $row) {
    DBConnection::handle();

    $q = "SELECT option_value from $table WHERE row = $row";
    $blob_query = mysql_query($q);
    while ($a = mysql_fetch_object($blob_query))
        $blob = $a->option_value;

    if (!isset($blob)) return FALSE;
    return $blob;
}

function description($input) {
    $Desriptions = array ( "Support web page where your users can learn how to configure and use eduroam" => "local_url",
            "Support web page for specific EAP types" => "local_support",
            "Support phone number which your users can call if they need help" => "local_email"
    );

    $find = array_search($input,$Descriptions);

    if ( $find === FALSE ) {
        return $input;
    }
    else {
        return $find;
    }

}

function availableOptions($class_name = 0) {

    DBConnection::handle();

    $q = "SELECT name from profile_option_dict".( $class_name ? " WHERE name LIKE '".$class_name."%'" : "");
    $options = mysql_query($q);

    $returnarray = array();

    while($a = mysql_fetch_object($options))
        $returnarray[] = $a->name;

    if ($class_name == "general") $returnarray[] = "general:logo_url";
    if ($class_name == "eap") $returnarray[] = "eap:ca_url";

    return $returnarray;
}

function downloadFile ($url) {
    $cadata;
    if (preg_match("/:\/\//", $url)) {
        # we got a URL, download it
        $download = fopen($url,"rb");
        $cadata = stream_get_contents($download);
        if(! $cadata )
            error("Failed to download the file form $url");
        return($cadata);
    } else {
        error("The specified string does not seem to be a URL!");
    }
}

/**
 * generates a UUID
 *
 * @param string $prefix an extra prefix to set before the UUID
 * @return UUID (possibly prefixed)
 */
function uuid($prefix = '') {
    $chars = md5(uniqid(mt_rand(), true));
    $uuid  = substr($chars,0,8) . '-';
    $uuid .= substr($chars,8,4) . '-';
    $uuid .= substr($chars,12,4) . '-';
    $uuid .= substr($chars,16,4) . '-';
    $uuid .= substr($chars,20,12);
    return $prefix . $uuid;
}

function set_locale($domain, $hardsetlocale = 0) {

    debug(4,"set_locale($domain, $hardsetlocale)\n");
    if ($hardsetlocale !== 0)
        $lang_converted[] = $hardsetlocale;
    elseif (isset($_SERVER['HTTP_ACCEPT_LANGUAGE'])) {

        $langs = explode(",",$_SERVER["HTTP_ACCEPT_LANGUAGE"]);

        foreach ($langs as $lang) {
            preg_match("/(.*);+.*/", $lang, $result);
            $lang_converted[] = ($result[1] ? $result[1] : $lang);
        }
        // print_r($lang_converted);
    };
    // always add configured locale as last resort
    $lang_converted[] = Config::$DEFAULT_LOCALE['locale'];
    $lang_index = Config::$DEFAULT_LOCALE['lang_index'];

    foreach ($lang_converted as $try_lang) {
        // madness! setlocale is completely unflexible. If $try_lang is "en"
        // it will fail, because it only knows en_US, en_GB a.s.o.
        // we need to map stuff manually
        $thelang = $try_lang;
        
        foreach (Config::$LANGUAGES as $language => $value)
        if (preg_match("/^".$language.".*/", $try_lang)) {
            $thelang = $value['locale'];
            $lang_index = $language;
        }

        // echo "Trying to set language to $thelang...";
        putenv("LC_ALL=$thelang");
        if (setlocale(LC_ALL, $thelang)) break;
    }

    $b = textdomain($domain);
    $a = bindtextdomain($domain, Config::$BASE_DIR."/translation/");

    debug(4,"selected lang:$lang_index:$thelang\n");
    debug(4,$lang_converted);
    return $lang_index;

}

?>
