<?php
/**
 * This file contains Federation, IdP and Profile classes.
 * These should be split into separate files later.
 *
 * @package Developer
 */

/**
 * 
 */
require_once('Helper.php');
require_once('Profile.php');

/**
 * This class represents an Identity Provider (IdP).
 * IdPs have properties of their own, and may have one or more Profiles. The
 * profiles can override the institution-wide properties.
 *
 * @author Stefan Winter <stefan.winter@restena.lu>
 * @author Tomasz Wolniewicz <twoln@umk.pl>
 *
 * @license http://ticker.eduroam.lu/cat/LICENSE
 *
 * @package Developer
 */
class IdP {

    /**
     * Constructs an IdP object based on its details in the database.
     * Cannot be used to define a new IdP in the database! This happens via Federation::createIdP(),
     * which doesn't exist yet :-)
     *
     * @param integer $i_id the database row identifier
     */
    public function  __construct($i_id) {
        $this->identifier = $i_id;
           DBConnection::handle();
           $q = "SELECT inst_id, inst_name, country FROM institution WHERE inst_id = $i_id";
	   debug(5,$q."\n");
           $idp = mysql_query($q);
           if (! $a = mysql_fetch_object($idp) ) {
               debug(2,"Can't construct an IdP: Identifier *$i_id* doesn't exist in DB!\n");
               exit(1);
           }
           $this->name = $a->inst_name;
           $this->federation = $a->country;
    }

    /**
     * This function retrieves all registered profiles for this IdP from the database
     *
     * @return array List of Profiles of this IdP
     */
    public function listProfiles() {
       $q = "SELECT profile_id,name FROM profile 
             WHERE inst_id = $this->identifier ORDER BY name";
       debug(5,$q."\n");
       $allProfiles = mysql_query($q);
       $returnarray = array();
       while($a = mysql_fetch_object($allProfiles)) {
           $k = new Profile($a->profile_id);
           $k->name = $a->name;
           $k->institution = $this->identifier;
           $returnarray[] = $k;
       }
       return $returnarray;
    }

    /**
     * retrieves the IdP-wide attributes
     *
     * @return array Array of arrays of attributes which were set for this IdP
     *
     */
    public function getAttributes($option_name = 0) {
        DBConnection::handle();

        $q = "SELECT DISTINCT option_name,option_value, row FROM institution_option
              WHERE institution_id = $this->identifier ".($option_name ? "AND option_name = '$option_name'" : "")." ORDER BY option_name";
         
        
        debug(5,$q."\n");
       $IdPAttributes = mysql_query($q);

       $returnarray = array();

       while($a = mysql_fetch_object($IdPAttributes)) {
           $returnarray[] = array( "name" => $a->option_name, "value" => $a->option_value, "level" => "IdP", "row" => $a->row);
       }
       if(!$option_name) {
       $returnarray[] = array("name" => "internal:inst_name", "value" => $this->name, "level" => "IdP", "row" => 0);
       $returnarray[] = array("name" => "internal:country", "value" => $this->federation, "level" => "IdP", "row" => 0);
       }

       return $returnarray;
    }

    /**
     * deletes all attributes of this IdP from the database
     */
    public function flushAttributes() {
        commitFlushAttributes(beginFlushAttributes());
    }

     /**
      * deletes all attributes in this profile except the _file ones, these are reported as array
      *
      * @return array list of row id's of file-based attributes which weren't deleted
      */
public function beginFlushAttributes() {
         $q_delete = "DELETE FROM institution_option WHERE institution_id = $this->identifier option_name NOT LIKE '%_file'";
	 debug(5,$q_delete."\n");
         $exec_q = mysql_query($q_delete);
         $q_remaining = "SELECT row FROM institution_option WHERE institution_id = $this->identifier";
         $exec_q = mysql_query($q_remaining);
         $return_array = array();
         while ($a = mysql_fetch_object($exec_q))
             $return_array[$a->row] = "KILLME";
         return $return_array;
}
/**
 * after a beginFlushAttributes, deletes all attributes which are in the tobedeleted array
 *
 * @param array $tobedeleted array of database rows which are to be deleted
 */
public function commitFlushAttributes($tobedeleted) {
    foreach ($tobedeleted as $row => $unimportant) {
        $q_delete = "DELETE FROM institution_option WHERE institution_id = $this->identifier AND row = $row";
	debug(5,$q_delete."\n");
        $exec_q = mysql_query($q_delete);
    }
}

    /**
     * Adds an attribute for the IdP instance into the database. Multiple instances of the same attribute are supported.
     *
     * @param string $attr_name Name of the attribute. This must be a well-known value from the profile_option_dict table in the DB.
     * @param mixed $attr_value Value of the attribute. Can be anything; will be stored in the DB as-is.
     */
    public function addAttribute($attr_name, $attr_value) {
        $q_insert = "INSERT INTO institution_option (institution_id, option_name, option_value) VALUES("
                         .$this->identifier.", '"
                         .$attr_name."', '"
                         .$attr_value
                         ."')";
	debug(5,$q_insert."\n");
        $exec_q = mysql_query($q_insert);
    }

    /**
     * Adds a new profile to this IdP.
     * Only creates the DB entry for the Profile and sets its name. If you want
     * to add attributes later, see Profile::addAttribute()
     *
     * @param string $name Display Name of the profile
     * @return object new Profile object if successful, or FALSE if an error occured
     */
    public function newProfile($name) {
 	 	 	DBConnection::handle();
 	 	 	$q_new = "INSERT INTO profile (name, inst_id) VALUES('".$name."',$this->identifier)";
	                debug(5,$q_new."\n");
 	 	 	$q_newhandle = "SELECT profile_id from profile WHERE name = '".$name."' AND inst_id = $this->identifier";
	                debug(5,$q_newhandle."\n");

                        $exec_newprofile = mysql_query($q_new);
 	 	 	$newhandle = mysql_query($q_newhandle);

                        if ($a = mysql_fetch_object($newhandle)) {
                             return new Profile($a->profile_id);
 	 	 	} else {
 	 	 	     return NULL;
 	 	 	}
    }
    
    /**
     * The shortname of this IdP's federation
     * @var string 
     */
    public $federation;
    /**
     * The row index of this IdP in the database
     * @var int 
     */
    public $identifier;
    /**
     * The name of this IdP
     * @var string 
     */
    public $name;
}

?>
