<?php

/*
 *      mod_imgDB.php
 * 
 *              Author Claude TOMPERS <claude.tompers@restena.lu>
 */

require_once(dirname(dirname(dirname(dirname(__FILE__))))."/config/_config.php");
require_once("Helper.php");
require_once("common.inc.php");

function getImageFromDB( $id ) {

        $blob = getBlobFromDB($id);

        if ($blob === FALSE) return;

        // Set file type and caching for 30 days
        $info = new finfo();
        $filetype = $info->buffer($blob, FILEINFO_MIME_TYPE);

        header( "Content-type: ".$filetype );
        if ($filetype == "text/rtf" || $filetype == "application/rtf")
            header( "Content-Disposition: attachment; filename='download.rtf'");
        if ($filetype == "text/plain")
            header( "Content-Disposition: attachment; filename='download.txt'");
        header( "Cache-Control: must-revalidate" );
        $offset = 60 * 60 * 24 * 30;
        $ExpStr = "Expires: " . gmdate( "D, d M Y H:i:s", time() + $offset ) . " GMT";
        header( $ExpStr );

        //  Print out the image
        echo $blob;

}


if ( isset( $_GET[ "id" ] ) ) {
                getImageFromDB( $_GET[ "id" ] );
} else {
        echo "No valid ID";
}

?>