<?php
/**
 * This is the main (and currently: only) configuration file for CAT
 *
 * @package Configuration
 */

/**
 * This classes' members hold the configuration for CAT
 *
 * @author Stefan Winter <stefan.winter@restena.lu>
 * @author Tomasz Wolniewicz <twoln@umk.pl>
 *
 * @package Configuration
 */
class Config {
    /**
     * Database server that contains all the user data
     * @var string 
     */
    public static $KB_HOST="cat-test.eduroam.org";
    /**
     * Database name on the server
     * @var string 
     */
    public static $KB_DB="eduroam_configurator";
    /**
     * Username to access the database for the user GUI
     * @var string
     */
    public static $KB_CAT_USER="cat";
    /**
     * Username to access the database
     * @var string
     */
    public static $KB_CAT_PASS="cat_access";
    /**
     * Password to access the database
     * @var string
     */
    public static $KB_USER="stefan";
    /**
     * Password to access the database
     * @var string
     */
    public static $KB_PASS="p234jsyxt";
    /**
     * Base path for temporary files (these will hold site installer data)
     * @var string
     */
    public static $TMP_BASE_PATH="User_files/";
    /**
     * The CAT uses Google places to guess a location based on the country and name. You need to have a valid Google Places API key for that. Note that this is different from the Google Maps API key, below.
     * @var string
     */
    public static $PLACES_API_KEY="somekey";
    /**
     * Your API key for Google Maps. If this config variable is invalid, all the map parts won't work.
     * @var string
     */
    public static $MAPS_API_KEY="someotherkey";
    /**
     * Maximum size of files to be uploaded. Clever people can circumvent this; in the end, the hard limit is configured in php.ini
     * @var int
     */
    public static $MAX_UPLOAD_SIZE = 10000000;
    /**
     * Verbosity of some of the core code. The following debug levels are supported:
     *   1 = production (silence)
     *   2 = normal debug
     *   3 = more debug
     *   4 = annoyingly much debug output
     *   5 = way too much debug output (level 4 + SQL query dump)
     *
     * @var int
     *
     */
    public static $DEBUG_LEVEL=5;
    /**
     * Destination for debug logs
     * @var string
     */
    public static $DEBUG_FILE='/tmp/cat.log';

    /**
     * The RADIUS proxies to contact for static realm reachability checks
     * @var array
     */
    public static $RADIUS_HOSTS=array (
        array ('display_name' => 'Europe/Luxembourg', 'ip' => '5.6.7.8', 'secret' => 'somesecret', 'timeout' => 5),
        array ('display_name' => 'Otherregion', 'ip' => '1.2.3.4', 'secret' => 'whatever', 'timeout' => 5),
        );

    public static $LANGUAGES = array (
      'de' => array ('display' => 'Deutsch', 'locale' => 'de_DE.utf8', 'win_cp' => 'cp1252'),
      'en' => array ('display' => 'English(GB)', 'locale' => 'en_GB.utf8', 'win_cp' => 'cp1252'),
      'es' => array ('display' => 'Español', 'locale' => 'es_ES.utf8', 'win_cp' => 'cp1250'),
      'hr' => array ('display' => 'Hrvatski', 'locale' => 'hr_HR.utf8', 'win_cp' => 'cp1250'),
      'pl' => array ('display' => 'Polski', 'locale' => 'pl_PL.utf8', 'win_cp' => 'cp1250'),
    );
    /**
     * Sets the default locale.
     * If a user signals a preferred (and supported) language via browser settings, or clicks
     * on a language, this field is not used.
     * @var string
     */
    public static $DEFAULT_LOCALE = array('lang_index' => 'en', 'locale' => 'en_GB.utf8');

    public static $CONSORTIUM_NAME = "eduroam";
    public static $PRODUCT_NAME = "eduroam CAT";
    public static $PRODUCT_NAME_LONG = "eduroam Configuration Assistant Tool";

}

?>
