<?php
/**
 * This file contains the EAP class and some constants for EAP types.
 *
 * @author Stefan Winter <stefan.winter@restena.lu>
 * @author Tomasz Wolniewicz <twoln@umk.pl>
 *
 * @package Developer
 * 
 */

/**
 * some constants. Will PHPDoc render these nicely?
 */
define("PEAP",25);
define("MSCHAP2",26);
define("TTLS",21);
define("TLS",13);
define("NONE",0);
define("GTC",6);
define("FAST", 43);

require_once('DBConnection.php');

/**
 * Convenience functions for EAP types
 *
 * @author Stefan Winter <stefan.winter@restena.lu>
 * @author Tomasz Wolniewicz <twoln@umk.pl>
 *
 * @license http://ticker.eduroam.lu/cat/LICENSE
 *
 * @package Developer
 */
class EAP {

/* constants only work for simple types. So these arrays need to be variables. :-(
   Don't ever change them though. */

public static $PEAP_MSCHAP2 = array("OUTER" => PEAP, "INNER" => MSCHAP2);
public static $TLS      =     array("OUTER" => TLS, "INNER" => NONE);
public static $TTLS_PAP =     array("OUTER" => TTLS, "INNER" => NONE);
public static $TTLS_MSCHAP2 = array("OUTER" => TTLS, "INNER" => MSCHAP2);
public static $TTLS_GTC =     array("OUTER" => TTLS, "INNER" => GTC);
public static $FAST_GTC =     array("OUTER" => FAST, "INNER" => GTC);
public static $EAP_NONE =     array("OUTER" => NONE, "INNER" => NONE);

public static function listKnownEAPTypes() {
    DBConnection::handle();
    $returnarray = array();
    $q_methods = "SELECT php_serialized FROM eap_method ORDER BY display_name";
    $methods = mysql_query($q_methods);
    while ($a = mysql_fetch_object($methods))
        $returnarray[] = unserialize($a->php_serialized);
    return $returnarray;
}
}

?>
