<?php
include(dirname(dirname(dirname(__FILE__)))."/config/_config.php");
require_once("Helper.php");
require_once("Federation.php");
require_once("IdP.php");
require_once("Profile.php");
require_once("web/user/GUI.php");
require_once("devices/devices.php");
set_locale("web_user");

function displayDeviceStatus($s) {
   if($s > 0)
     return(_('not available with settings provided by your institution'));
   return(''); 
}

$command = substr($_SERVER['PATH_INFO'],1);
if( ! $command) 
  $command = 1;

$ARG=explode('/',$command);

$page = array_shift($ARG);

$new_page = $page + 1;

 $command = implode('/',$ARG);

  if($ARG) {
    $country = array_shift($ARG);
    $F = new Federation($country);
  }
  if($ARG) {
    $idp = array_shift($ARG);
    $Idp = new IdP($idp);
  }
  if($ARG) {
    $profile = array_shift($ARG);
    $P = new Profile($profile);
  }
  if($ARG)
    $device = array_shift($ARG);


function printLn ($new_page, $arg,$text,$status = '') {
global $command;
    if($status)
      print "<li>$text -<span style='color:red'> $status</span>\n";
    else
      print '<li><a href="'.$_SERVER['SCRIPT_NAME'].'/'.$new_page.'/'.$command.'/'.$arg.'?lang='.Globals::$lang_index.'">'.$text."</a>\n";
}

?>
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head xml:lang="en"> 
<meta charset="utf-8" /> 
<link rel="stylesheet" media="screen" type="text/css" href="css/cat-user-simple.css" />
</head>
<body>
<img src="<?php echo dirname($_SERVER['SCRIPT_NAME'])?>../resources/images/consortium_logo.png" align="right" style="padding-right:20px; padding-top:20px" alt="logo" />
<pre>
<?php 
//print_r($_SERVER); print_r($_REQUEST);
 ?>
</pre>
<div id="heading">
<?php echo _('This is a service under preparation, do not expect it to work.')?>
</div>
<?php
print '<h1><a href="'.$_SERVER['SCRIPT_NAME'].'?lang='.Globals::$lang_index.'">'.Config::$PRODUCT_NAME.'</a> '._('page').' '.$page.'</h1>';
echo _("View this page in");?>
    <?php
    foreach (Config::$LANGUAGES as $lang => $value) {
        echo "<a href='".$place['path'].( $short == "" ? "?" : "?".$short."&" )."lang=$lang'>".$value['display']."</a> ";
    }


if($idp)
  print "<h4>"._('Your institution:')." ".$Idp->name."</h4>\n";

$returnarray= array();
switch ($page) {
   case 1:
      $FED=Federation::printCountryList(1);
      foreach($FED as $f=>$F)
        $returnarray[] = array(strtolower($f), $F);   
     break;
   case 2:
      $Inst = $F->listIdentityProviders(1);
      $returnarray= array();
      foreach ($Inst as $I)
        $returnarray[] = array($I['entityID'],$I['title']);
     break;
   case 3:
      $Prof = $Idp->listProfiles();
      $returnarray= array();
      if(count($Prof) == 1) {
          $ARG[] = $Prof[0]->identifier;
          $profile = $Prof[0]->identifier;
          $P = new Profile($profile);
          $command .= '/'.$profile;
          $page = $page + 1;
       } else {
         foreach ($Prof as $P)
           $returnarray[] = array($P->identifier,$P->name);
           break;
       }
   case 4:
  print "<h4>"._('Your user group:')." ".$P->name."</h4>\n";
  $a = GUI::profileAttributes($profile);
  print _("If you encounter problems you should ask for help at your home institution");
  if($a['local_email']) 
    print '<p>Email: <a href="mailto:'.$a['local_email'].'">'.$a['local_email'].'</a>';
  if($a['local_url']) 
    print '<p>WWW: <a href="'.$a['local_url'].'">'.$a['local_url'].'</a>';
  if($a['local_phone']) 
    print '<p>Tel: <a href="'.$a['local_phone'].'">'.$a['local_phone'].'</a>';
  print '<h2>'._('Choose an installer to download').'</h2>';
  set_locale('devices');
  $thedevices = $P->listDevices();
  foreach( $thedevices as $D)
    $returnarray[] = array($D['id'],$D['display'],displayDeviceStatus($D['status']));
  set_locale("web_user");
     break;
   case 5:

  if(!$P->institution || $P->institution !== $idp) {
    print _("Profile does not match the institution");
    return;
  }

  print "<h4>"._('Your user group:')." ".$P->name."</h4>\n";
  $o = GUI::generateInstaller($device,$profile);
  if(! $o['link']) {
     print _("no configurator avalable for these input data");
     return;
  }
  print '<a href="/'.$o['link'].'">'._('Download</a> installer for').' '.$thedevices[$device]['display'];
     break;
   default:
     break;
}
$page ++;
print '<ul>';
foreach ($returnarray as $A) {
   $a = isset($A[2]) ? $A[2] : '';
   printLn($page,$A[0],$A[1],$a);
}
?>
</ul>
</body>
</html>
