<?php

require_once dirname(__FILE__) . '/../../../../branches/branch_1_0/core/Options.php';

/**
 * Test class for Options.
 * Generated by PHPUnit on 2013-07-02 at 07:14:13.
 */
class OptionsTest extends PHPUnit_Framework_TestCase {

    /**
     * @var Options
     */
    protected $object;

    /**
     * Sets up the fixture, for example, opens a network connection.
     * This method is called before a test is executed.
     */
    protected function setUp() {
        $this->object = Options::instance();
    }

    /**
     * Tears down the fixture, for example, closes a network connection.
     * This method is called after a test is executed.
     */
    protected function tearDown() {
        
    }

    /**
     * Generated from @assert ("user") == Array("user:email","user:fedadmin","user:realname").
     *
     * @covers Options::availableOptions
     */
    public function testAvailableOptions() {
        $this->assertEquals(
                Array("user:email", "user:fedadmin", "user:realname"), $this->object->availableOptions("user")
        );
    }

    /**
     * Generated from @assert ("general:instname") == Array("type"=>"string", "flag"=>"ML").
     *
     * @covers Options::optionType
     */
    public function testOptionType() {
        $this->assertEquals(
                Array("type" => "string", "flag" => "ML"), $this->object->optionType("general:instname")
        );
    }

    /**
     * Generated from @assert ("profile:production") == Array("type"=>"boolean", "flag"=>NULL).
     *
     * @covers Options::optionType
     */
    public function testOptionType2() {
        $this->assertEquals(
                Array("type" => "boolean", "flag" => NULL), $this->object->optionType("profile:production")
        );
    }

    /**
     * @covers Options::instance
     */
    public function testInstance() {
        // see if the class is instantiated correctly; is the case if all options
        // were created. Pick one from DB, one internal to verify.
        $thesameinstance = Options::instance();
        $theoptions = $thesameinstance->availableOptions();
        $this->assertContains("internal:country", $theoptions);
        $this->assertContains("general:instname", $theoptions);
    }

    /**
     * @covers {className}::{origMethodName}
     * @todo Implement test__clone().
     */
    public function test__clone() {
        // Remove the following lines when you implement this test.
        $this->markTestIncomplete(
                'This test has not been implemented yet.'
        );
    }

}

?>
