<?php
/* * *********************************************************************************
 * (c) 2011-12 DANTE Ltd. on behalf of the GN3 consortium
 * License: see the LICENSE file in the root directory
 * ********************************************************************************* */
?>
<?php
/**
 * Front-end for the user GUI
 *
 * @author Tomasz Wolniewicz <twoln@umk.pl>
 * @package UserGUI
 */
include(dirname(dirname(__FILE__)) . "/config/_config.php");
require_once("user/GUI.php");
require_once("devices/devices.php");
$Gui = new GUI();
$Gui->set_locale("web_user");
debug(4, "\n---------------------- index.php START --------------------------\n");
//debug(4,$_REQUEST);

/**
  * Menu class helps to define the menu on the main page
  */
class Menu {
/**
  * the constructor takes an array argument defining menu items.
  * the array must be indexed by strings which will be passed to user/cat_info.php a the page argument
  * the values of the array can be either a simple string which is passed to user/cat_info.php
  * as the title argument or an two element array - the first element of this array will be
  * the title and the second is a style specification applied to the given menu item
 */
public function __construct($menu_array) {
  $this->menu = $menu_array;
}

private function printMenuLine($index,$title="",$style="") {
print  "<tr><td style='$style'><a href='javascript:infoCAT(\"$index\",\"$title\")'>$title</a></td></tr>\n";
}

public function printMenu() {
  foreach ($this->menu as $index => $title)
  if(is_array($title))
     $this->printMenuLine($index,$title[0],$title[1]); 
  else
     $this->printMenuLine($index,$title); 
}

private $menu;
}
?>
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="<?php echo $Gui->lang_index ?>">
    <head lang="<?php echo $Gui->lang_index ?>"> 
        <script type="text/javascript">
            if(screen.width <= 480) {
                window.location.href = "<?php echo rtrim(dirname($_SERVER['SCRIPT_NAME']), '/') ?>/basic.php?<?php echo $_SERVER['QUERY_STRING'] ?>";
            }
        </script>
        <meta charset="utf-8" /> 
        <title><?php echo Config::$APPEARANCE['productname_long'];?></title>
        <script type="text/javascript">ie_version=0;</script>
        <!--[if IE]>
        <script type="text/javascript">ie_version=1;</script>
        <![endif]-->
        <!--[if IE 7]>
        <script type="text/javascript">ie_version=7;</script>
        <![endif]-->
        <!--[if IE 8]>
        <script type="text/javascript">ie_version=8;</script>
        <![endif]-->
        <!--[if IE 9]>
        <script type="text/javascript">ie_version=9;</script>
        <![endif]-->
        <!--[if IE 10]>
        <script type="text/javascript">ie_version=10;</script>
        <![endif]-->

        <link rel="stylesheet" media="screen" type="text/css" href="resources/css/cat.css" />
        <link rel="stylesheet" media="screen" type="text/css" href="resources/css/cat-user.css" />
        <!-- JQuery --> 
        <script type="text/javascript" src="external/jquery/jquery.js"></script> 
        <script type="text/javascript" src="external/jquery/jquery-ui.js"></script> 
        <!-- JQuery --> 
        <script type="text/javascript">
<?php
if (preg_match('/Android/', $_SERVER['HTTP_USER_AGENT']))
    $profile_list_size = 1;
else
    $profile_list_size = 4;
include("user/js/roll.php");
include("user/js/cat_js.php");
?>
    var loading_ico = new Image();
    loading_ico.src="resources/images/icons/loading51.gif";
        </script>
        <?php $Gui->set_locale("web_user"); ?>
        <!-- DiscoJuice -->
        <script type="text/javascript" src="external/discojuice/discojuice.js"></script>
        <script type="text/javascript">
            var lang = "<?php echo($Gui->lang_index) ?>";
        </script>
        <link rel="stylesheet" type="text/css" href="external/discojuice/css/discojuice.css" />
    </head>
    <body>
        <div id="heading">
            <?php
            print '<img src="resources/images/consortium_logo.png" alt="Consortium Logo" style="float:right; padding-right:20px; padding-top:20px"/>';
            print '<div id="motd">'.( isset(Config::$APPEARANCE['MOTD']) ? Config::$APPEARANCE['MOTD'] : '&nbsp' ).'</div>';
            print '<h1 style="padding-bottom:0px; height:1em;">' . sprintf(_("Welcome to %s"), Config::$APPEARANCE['productname']) . '</h1>
<h2 style="padding-bottom:0px; height:0px; vertical-align:bottom;">' . Config::$APPEARANCE['productname_long'] . '</h2>';
            echo '<table id="lang_select"><tr><td>';
            echo _("View this page in");
            ?>
            <?php
            foreach (Config::$LANGUAGES as $lang => $value) {
                echo "<a href='javascript:changeLang(\"$lang\")'>" . $value['display'] . "</a> ";
            }
            echo '</td><td style="text-align:right;padding-right:20px"><a href="' . dirname($_SERVER['SCRIPT_NAME']) . '?lang=' . $Gui->lang_index . '">' . _("Start page") . '</a></td></tr></table>';
            ?>
        </div>
        <div id="loading_ico">
            <?php echo _("Authenticating") . "..." ?><br><img src="resources/images/icons/loading51.gif" alt="Authenticating ..."/>
        </div>
        <div id="info_overlay">
            <div id="info_window"></div>
            <span id="close_button"><?php echo _("Close") ?></span>
        </div>
        <div id="main_body">
            <form id="cat_form" name="cat_form" method="POST" action="<?php echo rtrim(dirname($_SERVER['SCRIPT_NAME']), '/'); ?>/">
<?php if(! isset($_REQUEST['idp']) || ! $_REQUEST['idp']) { ?>
                <table id="front_page" style="width:100%; height:600px; border-spacing:0; border-collapse:collapse;">
                    <tr>
                        <td rowspan=2 style="border-right:solid; border-color: #bcd7e8; border-width:5px; min-height:400px; padding-left: 10px; vertical-align:top; width:110px; padding-top:30px;">
                            <table id="left_menu" style="border: 0 none; padding: 0;">
<?php
                                $menu = new Menu( array(
                                   "about_consortium"=>array(sprintf(_("About %s"), Config::$CONSORTIUM['name']),'padding-bottom:20px;font-weight: bold; '),
                                   "about"=>sprintf(_("About %s"), Config::$APPEARANCE['productname']),
                                   "tou"=>sprintf(_("Terms of use")),
                                   "faq"=>sprintf(_("FAQ")),
                                   "report"=>sprintf(_("Report a problem")),
                                   "develop"=>sprintf(_("Become a CAT developer")),
                                   "admin"=>array(sprintf(_("%s admin:<br>manage your IdP"), Config::$CONSORTIUM['name']),'padding-top:30px;'),
                                ));

                                $menu->printMenu(); ?>
                            </table>
                        </td>
                        <td style="vertical-align: top; height:280px; background: #fff; padding-left: 20px; padding-right: 20px">
                            <div id="main_menu_info" style="display:none">
                                    <img id="main_menu_close" src="resources/images/icons/button_cancel.png"  style="float:right"/>
                                <div id="main_menu_content"></div>
                            </div>
                            <table style="background: #fff; width:100%; padding-top: 5px">
                                <tr>
                                    <td id="slides" style="background: #fff url(resources/images/gradient-bg.png) repeat-x; height:272px; border-radius: 16px; width: 100%; padding-left:20px;">
                                        <div>
                                            <span id="line1" style="top:145px; color: #0A698E; font-size:20px"><?php printf(_("%s installation made easy:"), Config::$CONSORTIUM['name']) ?></span>
                                            <span id="line2" style="top:180px; font-size:40px"></span>
                                            <span id="line3" style="top:245px; left: 200px; color: maroon; font-size:25px"></span>
                                            <span id="line4" style="top:305px; width: 400px;"><?php echo _("Custom built for your home institution") ?></span>
                                            <span id="line5" style="top:345px; width: 400px; "><?php echo _("Digitally signed by the organisation that runs eduroam: TERENA") ?></span>
                                        </div>
                                        <img id="img_roll_0" src="resources/images/empty.png" alt="Rollover 0"/> <img id="img_roll_1" src="resources/images/empty.png" alt="Rollover 1"/>
                                    </td>
                                </tr>
                            </table>
                        </td>
                    </tr>
                    <tr>
                        <td id="user_button_td" style="text-align:center; vertical-align:top; padding-top:150px;">
<?php print '<span id="signin"><button class="signin signin_large" style="" id="user_button1"><span id="user_button">' . sprintf(_("%s user:<br>download your %s installer"), Config::$CONSORTIUM['name'], Config::$CONSORTIUM['name']) . '</span></button></span><span style="padding-left:50px">&nbsp;</span>'; ?>

<!--                            <?php print '<div id="user_button"><span id="signin"><button class="signin signin_large" style="font-size:20px;">' . sprintf(_("%s user:<br>download your %s installer"), Config::$CONSORTIUM['name'], Config::$CONSORTIUM['name']) . '</button></span></div><span style="padding-left:50px">&nbsp;</span>'; ?> -->
                        </td>
                    </tr>
                </table>
<?php } ?>
                <div id="user_page">
                    <div id="institution_name">
                        <span id="inst_name_span"></span>
                        <button class="signin">
                            <?php echo _("select another"); ?>
                        </button>
                    </div>
                    <div>
                        <img id="idp_logo" src="resources/images/empty.png" alt="IdP Logo"/>
                    </div>
                    <div id="profiles">
                        <div id="profiles_h" class="sub_h">
                            <?php echo _("Select the user group"); ?>
                        </div>
                        <table>
                            <tr>
                                <td><select id="profile_list"></select></td>
                                <td><div id="profile_desc" class="profile_desc"></div></td>
                            </tr>
                        </table>
                    </div>
                    <div id="user_info"></div>
                    <div id="profile_redirect">
                        <?php echo _("Your local administrator has specified that this user group should be supported locally.<br>
                            When you click <b>Continue</b> this support page will be opened in a new window/tab."); ?>
                        <br>
                            <span class="redirect_link">
                                <a id="profile_redirect_bt" href="" target="_blank"><?php echo _("Continue"); ?>
                                </a>
                            </span>
                    </div>
                    <div id="devices">
                        <div class="sub_h"><?php echo _("Choose an installer to download"); ?>
                            <div>
                                <table id="device_list" style="padding:0px;">
                                    <?php
                                    $Gui->set_locale("devices");
                                    foreach ($Gui->listDevices() as $group => $G) {
                                        $ct = count($G);
                                        $i = 0;
                                        print '<tbody><tr><td class="vendor" rowspan="' . $ct . '"><img src="resources/images/vendorlogo/' . $group . '.png" alt="'.$group.' Device"></td>';
                                        foreach ($G as $d => $D) {
                                            if ($i)
                                                print '<tr>';
                                            print "<td><button id='" . $d . "'>" . $D['display'] . "</button><div class='device_info' id='info_" . $d . "'></div></td>";
                                            print "<td><button class='more_info_b' id='info_b_" . $d . "'>i</button></td></tr>\n";
                                            $i++;
                                        }
                                        print "</tbody>";
                                    }
                                    $Gui->set_locale("web_user");
                                    ?>
                                </table>
                            </div>
                        </div>
                    </div>
                    <input type="hidden" name="profile" id="profile_id"/>
                    <input type="hidden" name="idp" id="inst_id"/>
                    <input type="hidden" name="inst_name" id="inst_name"/>
                    <input type="hidden" name="lang" id="lang"/>
                </div>
            </form>
        </div>
        <div class='footer'>
            <hr />
        <table style='width:100%'>
            <tr>
                <td style="padding-left:20px; padding-right:20px; text-align:left; vertical-align:top;">
                <?php
// this variable gets set during "make distribution" only
                    $RELEASE = "THERELEASE";
                    echo Config::$APPEARANCE['productname'] . " - ";
                    if ($RELEASE != "THERELEASE")
                        echo sprintf(_("Release %s"), $RELEASE);
                    else
                        echo _("Unreleased SVN Revision");
                    echo " &copy; 2011-12 DANTE Ltd. on behalf of the GN3 consortium";
                ?>
                 </td>
                 <td style="padding-left:80px; padding-right:20px; text-align:right; vertical-align:top;">
                 <?php
                     if (Config::$CONSORTIUM['name'] == "eduroam") // SW: APPROVED
                         echo "
                  <span id='logos' style='position:fixed; left:50%;'><img src='resources/images/dante.png' alt='DANTE' style='height:23px;width:47px'/>
                  <img src='resources/images/eu.png' alt='EU' style='height:23px;width:27px;border-width:0px;'/></span>
                  <span id='eu_text' style='text-align:right;'><a href='http://ec.europa.eu/dgs/connect/index_en.htm' style='text-decoration:none; vertical-align:top;'>European Commission Communications Networks, Content and Technology</a></span>";
                     else
                         echo "&nbsp;";
                 ?>
                </td>
            </tr>
        </table>
    </div>
    </body>
</html>
